VeraCrypt
aboutsummaryrefslogtreecommitdiff
path: root/src/Build
diff options
context:
space:
mode:
authorMounir IDRASSI <mounir.idrassi@idrix.fr>2024-07-06 16:36:56 +0200
committerGitHub <noreply@github.com>2024-07-06 16:36:56 +0200
commitbc5c32ad14a6607e7e91fb61c09a21e70ffeac8b (patch)
tree6e1b797b6b145dc0235b017ba40616b5e08b7893 /src/Build
parent3095fc265a2c4104953abc664a8640efb900e897 (diff)
downloadVeraCrypt-bc5c32ad14a6607e7e91fb61c09a21e70ffeac8b.tar.gz
VeraCrypt-bc5c32ad14a6607e7e91fb61c09a21e70ffeac8b.zip
Linux: Add Github CI workflow for Linux (#1374)
* Linux/MacOSX: during build, fallback to /tmp if wxWidgets sources not found in parent directory * Linux: Add Github workflow to build .deb files and test generated binaries * Linux: fix wrong wxWidgets extract path in yaml * fix: fix wrong wxWidgets extract path in yaml * Linux: harmonize content of test volumes and update Github workflow for this * Fix corrupted test container * Linux: optimize Github workflow by caching wxBuildConsole and wxBuildGUI folders We also modify build script to detect the presence of wxBuildConsole and wxBuildGUI folders and reuse them * Remove files mistakenly added * Linux: Fix wrong test for Github workflow * Linux: use static build of wxWidgets for GUI in Github workflow * Linux: upload also .deb SHA256SUM file if it is generated in Github workflow * Linux: fix detection logic of parent folder in build scripts * Github workflow: add build_cmake_deb.sh as trigger to build-linux.yml * Github workflow: add wxWidgets source code to the cache of workflow
Diffstat (limited to 'src/Build')
-rwxr-xr-xsrc/Build/build_cmake_deb.sh27
-rw-r--r--src/Build/build_cmake_opensuse.sh53
-rw-r--r--src/Build/build_cmake_rpm.sh49
-rwxr-xr-xsrc/Build/build_veracrypt_freebsd.sh50
-rwxr-xr-xsrc/Build/build_veracrypt_linux.sh49
-rwxr-xr-xsrc/Build/build_veracrypt_linux_no_sse2.sh49
-rwxr-xr-xsrc/Build/build_veracrypt_macosx.sh36
7 files changed, 239 insertions, 74 deletions
diff --git a/src/Build/build_cmake_deb.sh b/src/Build/build_cmake_deb.sh
index 17103a61..8bceb886 100755
--- a/src/Build/build_cmake_deb.sh
+++ b/src/Build/build_cmake_deb.sh
@@ -18,9 +18,26 @@ export SOURCEPATH=$(readlink -f "$SCRIPTPATH/..")
# Directory where the VeraCrypt has been checked out
export PARENTDIR=$(readlink -f "$SCRIPTPATH/../../..")
+# Check the condition of wxBuildConsole and wxWidgets-3.2.5 in the original PARENTDIR
+if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxBuildConsole is present."
+elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxWidgets-3.2.5 is present."
+else
+ # Change PARENTDIR to /tmp and check conditions again
+ export PARENTDIR="/tmp"
+ if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxBuildConsole is present in /tmp."
+ elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxWidgets-3.2.5 is present in /tmp."
+ else
+ echo "Error: Neither wxBuildConsole nor wxWidgets-3.2.5 found in /tmp. Exiting."
+ exit 1
+ fi
+fi
+
# The sources of wxWidgets 3.2.5 must be extracted to the parent directory
export WX_ROOT=$PARENTDIR/wxWidgets-3.2.5
-echo "Using wxWidgets sources in $WX_ROOT"
cd $SOURCEPATH
@@ -41,7 +58,13 @@ build_and_install() {
wxstatic_value=""
if [ "$wxstatic" = "WXSTATIC" ]; then
wxstatic_value="WXSTATIC=1"
- make $wxstatic_value $nogui wxbuild || exit 1
+ # Check if wx-config exists in WX_BUILD_DIR
+ if [ -L "${WX_BUILD_DIR}/wx-config" ]; then
+ echo "wx-config already exists in ${WX_BUILD_DIR}. Skipping wxbuild."
+ else
+ echo "Using wxWidgets sources in $WX_ROOT"
+ make $wxstatic_value $nogui wxbuild || exit 1
+ fi
fi
indicator_value=""
diff --git a/src/Build/build_cmake_opensuse.sh b/src/Build/build_cmake_opensuse.sh
index 52bed78a..13a75bec 100644
--- a/src/Build/build_cmake_opensuse.sh
+++ b/src/Build/build_cmake_opensuse.sh
@@ -18,9 +18,26 @@ export SOURCEPATH=$(readlink -f "$SCRIPTPATH/..")
# Directory where the VeraCrypt has been checked out
export PARENTDIR=$(readlink -f "$SCRIPTPATH/../../..")
+# Check the condition of wxBuildConsole and wxWidgets-3.2.5 in the original PARENTDIR
+if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxBuildConsole is present."
+elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxWidgets-3.2.5 is present."
+else
+ # Change PARENTDIR to /tmp and check conditions again
+ export PARENTDIR="/tmp"
+ if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxBuildConsole is present in /tmp."
+ elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxWidgets-3.2.5 is present in /tmp."
+ else
+ echo "Error: Neither wxBuildConsole nor wxWidgets-3.2.5 found in /tmp. Exiting."
+ exit 1
+ fi
+fi
+
# The sources of wxWidgets 3.2.5 must be extracted to the parent directory
export WX_ROOT=$PARENTDIR/wxWidgets-3.2.5
-echo "Using wxWidgets sources in $WX_ROOT"
cd $SOURCEPATH
@@ -29,18 +46,19 @@ echo "Building GUI version of VeraCrypt for RPM using wxWidgets static libraries
# This will be the temporary wxWidgets directory
export WX_BUILD_DIR=$PARENTDIR/wxBuildGui
-# To build wxWidgets using native GTK version
-make WXSTATIC=1 wxbuild || exit 1
-ln -s $WX_BUILD_DIR/lib $WX_BUILD_DIR/lib64
+# Check if wx-config exists in WX_BUILD_DIR
+if [ -L "${WX_BUILD_DIR}/wx-config" ]; then
+ echo "wx-config already exists in ${WX_BUILD_DIR}. Skipping wxbuild."
+else
+ echo "Using wxWidgets sources in $WX_ROOT"
+ make WXSTATIC=1 wxbuild || exit 1
+ ln -s $WX_BUILD_DIR/lib $WX_BUILD_DIR/lib64
+fi
+
make WXSTATIC=1 clean || exit 1
make WXSTATIC=1 || exit 1
make WXSTATIC=1 install DESTDIR="$PARENTDIR/VeraCrypt_Setup/GUI" || exit 1
-# Uncomment below and comment lines above to reuse existing wxWidgets build
-# make WXSTATIC=1 clean || exit 1
-# make WXSTATIC=1 || exit 1
-# make WXSTATIC=1 install DESTDIR="$PARENTDIR/VeraCrypt_Setup/GUI" || exit 1
-
echo "Building console version of VeraCrypt for RPM using wxWidgets static libraries"
# This is to avoid " Error: Unable to initialize GTK+, is DISPLAY set properly?"
@@ -50,18 +68,19 @@ echo "Building console version of VeraCrypt for RPM using wxWidgets static libra
# This will be the temporary wxWidgets directory
export WX_BUILD_DIR=$PARENTDIR/wxBuildConsole
-# To build wxWidgets using native GTK version
-make WXSTATIC=1 NOGUI=1 wxbuild || exit 1
-ln -s $WX_BUILD_DIR/lib $WX_BUILD_DIR/lib64
+# Check if wx-config exists in WX_BUILD_DIR
+if [ -L "${WX_BUILD_DIR}/wx-config" ]; then
+ echo "wx-config already exists in ${WX_BUILD_DIR}. Skipping wxbuild."
+else
+ echo "Using wxWidgets sources in $WX_ROOT"
+ make WXSTATIC=1 NOGUI=1 wxbuild || exit 1
+ ln -s $WX_BUILD_DIR/lib $WX_BUILD_DIR/lib64
+fi
+
make WXSTATIC=1 NOGUI=1 clean || exit 1
make WXSTATIC=1 NOGUI=1 || exit 1
make WXSTATIC=1 NOGUI=1 install DESTDIR="$PARENTDIR/VeraCrypt_Setup/Console" || exit 1
-# Uncomment below and comment lines above to reuse existing wxWidgets build
-# make WXSTATIC=1 NOGUI=1 clean || exit 1
-# make WXSTATIC=1 NOGUI=1 || exit 1
-# make WXSTATIC=1 NOGUI=1 install DESTDIR="$PARENTDIR/VeraCrypt_Setup/Console" || exit 1
-
echo "Creating VeraCrypt RPM packages "
# -DCPACK_RPM_PACKAGE_DEBUG=TRUE for debugging cpack RPM
diff --git a/src/Build/build_cmake_rpm.sh b/src/Build/build_cmake_rpm.sh
index 938bf40f..ba6ea355 100644
--- a/src/Build/build_cmake_rpm.sh
+++ b/src/Build/build_cmake_rpm.sh
@@ -18,9 +18,26 @@ export SOURCEPATH=$(readlink -f "$SCRIPTPATH/..")
# Directory where the VeraCrypt has been checked out
export PARENTDIR=$(readlink -f "$SCRIPTPATH/../../..")
+# Check the condition of wxBuildConsole and wxWidgets-3.2.5 in the original PARENTDIR
+if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxBuildConsole is present."
+elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxWidgets-3.2.5 is present."
+else
+ # Change PARENTDIR to /tmp and check conditions again
+ export PARENTDIR="/tmp"
+ if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxBuildConsole is present in /tmp."
+ elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxWidgets-3.2.5 is present in /tmp."
+ else
+ echo "Error: Neither wxBuildConsole nor wxWidgets-3.2.5 found in /tmp. Exiting."
+ exit 1
+ fi
+fi
+
# The sources of wxWidgets 3.2.5 must be extracted to the parent directory
export WX_ROOT=$PARENTDIR/wxWidgets-3.2.5
-echo "Using wxWidgets sources in $WX_ROOT"
cd $SOURCEPATH
@@ -29,17 +46,18 @@ echo "Building GUI version of VeraCrypt for RPM using wxWidgets static libraries
# This will be the temporary wxWidgets directory
export WX_BUILD_DIR=$PARENTDIR/wxBuildGui
-# To build wxWidgets using native GTK version
-make WXSTATIC=1 wxbuild || exit 1
+# Check if wx-config exists in WX_BUILD_DIR
+if [ -L "${WX_BUILD_DIR}/wx-config" ]; then
+ echo "wx-config already exists in ${WX_BUILD_DIR}. Skipping wxbuild."
+else
+ echo "Using wxWidgets sources in $WX_ROOT"
+ make WXSTATIC=1 wxbuild || exit 1
+fi
+
make WXSTATIC=1 clean || exit 1
make WXSTATIC=1 || exit 1
make WXSTATIC=1 install DESTDIR="$PARENTDIR/VeraCrypt_Setup/GUI" || exit 1
-# Uncomment below and comment lines above to reuse existing wxWidgets build
-# make WXSTATIC=1 clean || exit 1
-# make WXSTATIC=1 || exit 1
-# make WXSTATIC=1 install DESTDIR="$PARENTDIR/VeraCrypt_Setup/GUI" || exit 1
-
echo "Building console version of VeraCrypt for RPM using wxWidgets static libraries"
# This is to avoid " Error: Unable to initialize GTK+, is DISPLAY set properly?"
@@ -49,17 +67,18 @@ echo "Building console version of VeraCrypt for RPM using wxWidgets static libra
# This will be the temporary wxWidgets directory
export WX_BUILD_DIR=$PARENTDIR/wxBuildConsole
-# To build wxWidgets using native GTK version
-make WXSTATIC=1 NOGUI=1 wxbuild || exit 1
+# Check if wx-config exists in WX_BUILD_DIR
+if [ -L "${WX_BUILD_DIR}/wx-config" ]; then
+ echo "wx-config already exists in ${WX_BUILD_DIR}. Skipping wxbuild."
+else
+ echo "Using wxWidgets sources in $WX_ROOT"
+ make WXSTATIC=1 NOGUI=1 wxbuild || exit 1
+fi
+
make WXSTATIC=1 NOGUI=1 clean || exit 1
make WXSTATIC=1 NOGUI=1 || exit 1
make WXSTATIC=1 NOGUI=1 install DESTDIR="$PARENTDIR/VeraCrypt_Setup/Console" || exit 1
-# Uncomment below and comment lines above to reuse existing wxWidgets build
-# make WXSTATIC=1 NOGUI=1 clean || exit 1
-# make WXSTATIC=1 NOGUI=1 || exit 1
-# make WXSTATIC=1 NOGUI=1 install DESTDIR="$PARENTDIR/VeraCrypt_Setup/Console" || exit 1
-
echo "Creating VeraCrypt RPM packages "
# -DCPACK_RPM_PACKAGE_DEBUG=TRUE for debugging cpack RPM
diff --git a/src/Build/build_veracrypt_freebsd.sh b/src/Build/build_veracrypt_freebsd.sh
index fe7f1f84..892a7eed 100755
--- a/src/Build/build_veracrypt_freebsd.sh
+++ b/src/Build/build_veracrypt_freebsd.sh
@@ -15,15 +15,26 @@ SOURCEPATH=$(readlink -f "$SCRIPTPATH/..")
# directory where the VeraCrypt has been checked out
PARENTDIR=$(readlink -f "$SCRIPTPATH/../../..")
-# Make sure only root can run our script
-if [ "$(id -u)" != "0" ]; then
- echo "VeraCrypt must be built by root" 1>&2
- exit 1
+# Check the condition of wxBuildConsole and wxWidgets-3.2.5 in the original PARENTDIR
+if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxBuildConsole is present."
+elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxWidgets-3.2.5 is present."
+else
+ # Change PARENTDIR to /tmp and check conditions again
+ export PARENTDIR="/tmp"
+ if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxBuildConsole is present in /tmp."
+ elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxWidgets-3.2.5 is present in /tmp."
+ else
+ echo "Error: Neither wxBuildConsole nor wxWidgets-3.2.5 found in /tmp. Exiting."
+ exit 1
+ fi
fi
-# the sources of wxWidgets 3.2.5 must be extracted to the parent directory
+# The sources of wxWidgets 3.2.5 must be extracted to the parent directory
export WX_ROOT=$PARENTDIR/wxWidgets-3.2.5
-echo "Using wxWidgets sources in $WX_ROOT"
cd $SOURCEPATH
@@ -32,17 +43,30 @@ echo "Building GUI version of VeraCrypt"
# this will be the temporary wxWidgets directory
export WX_BUILD_DIR=$PARENTDIR/wxBuildGui
-gmake WXSTATIC=1 wxbuild && gmake WXSTATIC=1 clean && gmake WXSTATIC=1 && gmake WXSTATIC=1 package
+# Check if wx-config exists in WX_BUILD_DIR
+if [ -L "${WX_BUILD_DIR}/wx-config" ]; then
+ echo "wx-config already exists in ${WX_BUILD_DIR}. Skipping wxbuild."
+else
+ echo "Using wxWidgets sources in $WX_ROOT"
+ gmake WXSTATIC=1 wxbuild || exit 1
+fi
-# Uncomment below and comment line above to reuse existing wxWidgets build
-#gmake WXSTATIC=1 clean && gmake WXSTATIC=1 && gmake WXSTATIC=1 package
+gmake WXSTATIC=1 clean || exit 1
+gmake WXSTATIC=1 || exit 1
+gmake WXSTATIC=1 package || exit 1
echo "Building console version of VeraCrypt"
# this will be the temporary wxWidgets directory
export WX_BUILD_DIR=$PARENTDIR/wxBuildConsole
-gmake WXSTATIC=1 NOGUI=1 wxbuild && gmake WXSTATIC=1 NOGUI=1 clean && gmake WXSTATIC=1 NOGUI=1 && gmake WXSTATIC=1 NOGUI=1 package
-
-# Uncomment below and comment line above to reuse existing wxWidgets build
-#gmake WXSTATIC=1 NOGUI=1 clean && gmake WXSTATIC=1 NOGUI=1 && gmake WXSTATIC=1 NOGUI=1 package
+# Check if wx-config exists in WX_BUILD_DIR
+if [ -L "${WX_BUILD_DIR}/wx-config" ]; then
+ echo "wx-config already exists in ${WX_BUILD_DIR}. Skipping wxbuild."
+else
+ echo "Using wxWidgets sources in $WX_ROOT"
+ gmake WXSTATIC=1 NOGUI=1 wxbuild || exit 1
+fi
+gmake WXSTATIC=1 NOGUI=1 clean || exit 1
+gmake WXSTATIC=1 NOGUI=1 || exit 1
+gmake WXSTATIC=1 NOGUI=1 package || exit 1
diff --git a/src/Build/build_veracrypt_linux.sh b/src/Build/build_veracrypt_linux.sh
index f8c8c325..b6ac39ed 100755
--- a/src/Build/build_veracrypt_linux.sh
+++ b/src/Build/build_veracrypt_linux.sh
@@ -20,9 +20,26 @@ if [ "$(id -u)" != "0" ]; then
exit 1
fi
-# the sources of wxWidgets 3.2.5 must be extracted to the parent directory
+# Check the condition of wxBuildConsole and wxWidgets-3.2.5 in the original PARENTDIR
+if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxBuildConsole is present."
+elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxWidgets-3.2.5 is present."
+else
+ # Change PARENTDIR to /tmp and check conditions again
+ export PARENTDIR="/tmp"
+ if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxBuildConsole is present in /tmp."
+ elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxWidgets-3.2.5 is present in /tmp."
+ else
+ echo "Error: Neither wxBuildConsole nor wxWidgets-3.2.5 found in /tmp. Exiting."
+ exit 1
+ fi
+fi
+
+# The sources of wxWidgets 3.2.5 must be extracted to the parent directory
export WX_ROOT=$PARENTDIR/wxWidgets-3.2.5
-echo "Using wxWidgets sources in $WX_ROOT"
cd $SOURCEPATH
@@ -31,17 +48,29 @@ echo "Building GUI version of VeraCrypt"
# this will be the temporary wxWidgets directory
export WX_BUILD_DIR=$PARENTDIR/wxBuildGui
-make WXSTATIC=1 wxbuild && make WXSTATIC=1 clean && make WXSTATIC=1 && make WXSTATIC=1 package
-
-# Uncomment below and comment line above to reuse existing wxWidgets build
-# make WXSTATIC=1 clean && make WXSTATIC=1 && make WXSTATIC=1 package
+# Check if wx-config exists in WX_BUILD_DIR
+if [ -L "${WX_BUILD_DIR}/wx-config" ]; then
+ echo "wx-config already exists in ${WX_BUILD_DIR}. Skipping wxbuild."
+else
+ echo "Using wxWidgets sources in $WX_ROOT"
+ make WXSTATIC=1 wxbuild || exit 1
+fi
+make WXSTATIC=1 clean || exit 1
+make WXSTATIC=1 || exit 1
+make WXSTATIC=1 package || exit 1
echo "Building console version of VeraCrypt"
# this will be the temporary wxWidgets directory
export WX_BUILD_DIR=$PARENTDIR/wxBuildConsole
-make WXSTATIC=1 NOGUI=1 wxbuild && make WXSTATIC=1 NOGUI=1 clean && make WXSTATIC=1 NOGUI=1 && make WXSTATIC=1 NOGUI=1 package
-
-# Uncomment below and comment line above to reuse existing wxWidgets build
-# make WXSTATIC=1 NOGUI=1 clean && make WXSTATIC=1 NOGUI=1 && make WXSTATIC=1 NOGUI=1 package
+# Check if wx-config exists in WX_BUILD_DIR
+if [ -L "${WX_BUILD_DIR}/wx-config" ]; then
+ echo "wx-config already exists in ${WX_BUILD_DIR}. Skipping wxbuild."
+else
+ echo "Using wxWidgets sources in $WX_ROOT"
+ make WXSTATIC=1 NOGUI=1 wxbuild || exit 1
+fi
+make WXSTATIC=1 NOGUI=1 clean || exit 1
+make WXSTATIC=1 NOGUI=1 || exit 1
+make WXSTATIC=1 NOGUI=1 package || exit 1
diff --git a/src/Build/build_veracrypt_linux_no_sse2.sh b/src/Build/build_veracrypt_linux_no_sse2.sh
index 5f29dc49..6f0739c7 100755
--- a/src/Build/build_veracrypt_linux_no_sse2.sh
+++ b/src/Build/build_veracrypt_linux_no_sse2.sh
@@ -20,9 +20,26 @@ if [ "$(id -u)" != "0" ]; then
exit 1
fi
-# the sources of wxWidgets 3.2.5 must be extracted to the parent directory
+# Check the condition of wxBuildConsole and wxWidgets-3.2.5 in the original PARENTDIR
+if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxBuildConsole is present."
+elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxWidgets-3.2.5 is present."
+else
+ # Change PARENTDIR to /tmp and check conditions again
+ export PARENTDIR="/tmp"
+ if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxBuildConsole is present in /tmp."
+ elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxWidgets-3.2.5 is present in /tmp."
+ else
+ echo "Error: Neither wxBuildConsole nor wxWidgets-3.2.5 found in /tmp. Exiting."
+ exit 1
+ fi
+fi
+
+# The sources of wxWidgets 3.2.5 must be extracted to the parent directory
export WX_ROOT=$PARENTDIR/wxWidgets-3.2.5
-echo "Using wxWidgets sources in $WX_ROOT"
cd $SOURCEPATH
@@ -31,17 +48,29 @@ echo "Building GUI version of VeraCrypt"
# this will be the temporary wxWidgets directory
export WX_BUILD_DIR=$PARENTDIR/wxBuildGuiNoSSE2
-make WXSTATIC=1 NOSSE2=1 wxbuild && make WXSTATIC=1 NOSSE2=1 clean && make WXSTATIC=1 NOSSE2=1 && make WXSTATIC=1 NOSSE2=1 package
-
-# Uncomment below and comment line above to reuse existing wxWidgets build
-# make WXSTATIC=1 NOSSE2=1 clean && make WXSTATIC=1 NOSSE2=1 && make WXSTATIC=1 NOSSE2=1 package
+# Check if wx-config exists in WX_BUILD_DIR
+if [ -L "${WX_BUILD_DIR}/wx-config" ]; then
+ echo "wx-config already exists in ${WX_BUILD_DIR}. Skipping wxbuild."
+else
+ echo "Using wxWidgets sources in $WX_ROOT"
+ make WXSTATIC=1 NOSSE2=1 wxbuild || exit 1
+fi
+make WXSTATIC=1 NOSSE2=1 clean || exit 1
+make WXSTATIC=1 NOSSE2=1 || exit 1
+make WXSTATIC=1 NOSSE2=1 package || exit 1
echo "Building console version of VeraCrypt"
# this will be the temporary wxWidgets directory
export WX_BUILD_DIR=$PARENTDIR/wxBuildConsoleNoSSE2
-make WXSTATIC=1 NOGUI=1 NOSSE2=1 wxbuild && make WXSTATIC=1 NOGUI=1 NOSSE2=1 clean && make WXSTATIC=1 NOGUI=1 NOSSE2=1 && make WXSTATIC=1 NOGUI=1 NOSSE2=1 package
-
-# Uncomment below and comment line above to reuse existing wxWidgets build
-# make WXSTATIC=1 NOGUI=1 NOSSE2=1 clean && make WXSTATIC=1 NOGUI=1 NOSSE2=1 && make WXSTATIC=1 NOGUI=1 NOSSE2=1 package
+# Check if wx-config exists in WX_BUILD_DIR
+if [ -L "${WX_BUILD_DIR}/wx-config" ]; then
+ echo "wx-config already exists in ${WX_BUILD_DIR}. Skipping wxbuild."
+else
+ echo "Using wxWidgets sources in $WX_ROOT"
+ make WXSTATIC=1 NOGUI=1 NOSSE2=1 wxbuild || exit 1
+fi
+make WXSTATIC=1 NOGUI=1 NOSSE2=1 clean || exit 1
+make WXSTATIC=1 NOGUI=1 NOSSE2=1 || exit 1
+make WXSTATIC=1 NOGUI=1 NOSSE2=1 package || exit
diff --git a/src/Build/build_veracrypt_macosx.sh b/src/Build/build_veracrypt_macosx.sh
index aaaae8b5..5319fa6a 100755
--- a/src/Build/build_veracrypt_macosx.sh
+++ b/src/Build/build_veracrypt_macosx.sh
@@ -55,9 +55,26 @@ if [ -n "$brew" ]; then
exit 0
fi
-# the sources of wxWidgets 3.2.5 must be extracted to the parent directory (for night mode)
+# Check the condition of wxBuildConsole and wxWidgets-3.2.5 in the original PARENTDIR
+if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxBuildConsole is present."
+elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Using existing PARENTDIR: $PARENTDIR, wxWidgets-3.2.5 is present."
+else
+ # Change PARENTDIR to /tmp and check conditions again
+ export PARENTDIR="/tmp"
+ if [ -d "$PARENTDIR/wxBuildConsole" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxBuildConsole is present in /tmp."
+ elif [ -d "$PARENTDIR/wxWidgets-3.2.5" ]; then
+ echo "Switched to PARENTDIR: /tmp, wxWidgets-3.2.5 is present in /tmp."
+ else
+ echo "Error: Neither wxBuildConsole nor wxWidgets-3.2.5 found in /tmp. Exiting."
+ exit 1
+ fi
+fi
+
+# The sources of wxWidgets 3.2.5 must be extracted to the parent directory
export WX_ROOT=$PARENTDIR/wxWidgets-3.2.5
-echo "Using wxWidgets sources in $WX_ROOT"
# this will be the temporary wxWidgets directory
export WX_BUILD_DIR=$PARENTDIR/wxBuild-3.2.5
@@ -70,8 +87,13 @@ echo "Using MacOSX SDK $VC_OSX_SDK with target set to $VC_OSX_TARGET"
cd $SOURCEPATH
echo "Building VeraCrypt"
-make WXSTATIC=FULL wxbuild && make WXSTATIC=FULL clean && make WXSTATIC=FULL && make WXSTATIC=FULL package
-
-# Uncomment below and comment line above to reuse existing wxWidgets build
-# make WXSTATIC=FULL clean && make WXSTATIC=FULL && make WXSTATIC=FULL package
-
+# Check if wx-config exists in WX_BUILD_DIR
+if [ -L "${WX_BUILD_DIR}/wx-config" ]; then
+ echo "wx-config already exists in ${WX_BUILD_DIR}. Skipping wxbuild."
+else
+ echo "Using wxWidgets sources in $WX_ROOT"
+ make WXSTATIC=FULL wxbuild || exit 1
+fi
+make WXSTATIC=FULL clean || exit 1
+make WXSTATIC=FULL || exit 1
+make WXSTATIC=FULL package || exit 1